#!/bin/sh

awk '
# Fix rivers in maps flipped upside-down
# Run this on a map after flipmap.awk (make sure to keep map headers
# in other file; this does not preserve pre-plot information)
BEGIN {x=-1;y=-1}
{
# Map tiles
if(/BeginPlot/) {
	}
else if(/River/) {
	if(/isN/ || /WE/) {
		r = $0
		if(r ~ /RiverWEDirection=3/) {
			r = "\tRiverWEDirection=1"
		} else if (r ~ /RiverWEDirection=1/) {
			r = "\tRiverWEDirection=3"
		}
		rx = x 
		ry = y + 1
		rivern[rx " " ry] = rivern[rx " " ry] r "\n"
	} else if (/isW/ || /NS/) {
		r = $0
		if(r ~ /RiverNSDirection=0/) {
			r = "\tRiverNSDirection=2"
		} else if (r ~ /RiverNSDirection=2/) {
			r = "\tRiverNSDirection=0"
		}
		rx = x - 1
		ry = y
		riverw[rx " " ry] = riverw[rx " " ry] r "\n"
	}
}
else if(/x=([0-9]+),y=([0-9]+)/) {
        x=$0;
        sub(/.*x=/,"",x);sub(/,.*/,"",x);
        y=$0;
	sub(/.*y=/,"",y);
        }
else {
	plot[x " " y] = plot[x " " y] $0 "\n"
}
# Print modified map
}

END {
	for(x = 0; x < 76; x++) {
		for(y = 0; y < 60; y++) {
			print "BeginPlot"
			print "\tx=" x ",y=" y
			printf("%s", rivern[x " " y])
			printf("%s", riverw[x " " y])
			printf("%s", plot[x " " y])
		}
	}
}
'         
